package rozdzial18;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.ListCell;
import javafx.scene.control.ListView;
import javafx.scene.control.cell.TextFieldListCell;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import javafx.util.Callback;

//TextFieldListCell - zdarzenia edycji
public class Listing18_28 extends Application {
    public static void main(String[] args) {
        Application.launch(args);
    }

    @Override
    public void start(Stage stage) {
        try {
            VBox root = new VBox();
            Label label = new Label("Wybierz najładniejszą forme imienia: ");
            ObservableList<String> ol = FXCollections.observableArrayList(
                    "Urszula", "Ula", "Ulka", "Ulessa", "Uleńka");
            ListView<String> lv1 = new ListView<>(ol);
            lv1.setEditable(true);
            Callback<ListView<String>, ListCell<String>> cellFactory = TextFieldListCell
                    .forListView();
            lv1.setCellFactory(cellFactory);
            EventHandler<ListView.EditEvent<String>> handler = e -> {
                System.out.println(
                        "Typ zdarzenia: " + e.getEventType().getName());
                System.out.println("Indeks: " + e.getIndex());
                System.out.println("Nowa wartość: " + e.getNewValue());
            };
            lv1.setOnEditStart(handler);
            lv1.setOnEditCommit(handler);
            lv1.setOnEditCancel(handler);
            root.getChildren().addAll(label, lv1);
            Scene scene = new Scene(root, 200, 200);
            stage.setScene(scene);
            stage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
